/*
 * $Id: lparser.prg,v 1.1 1999/11/09 01:37:24 vszel Exp $
 */

//*******************************************************************
// lparser.prg: Az lparser osztly implementcija.
// 1999, Csiszr Levente
/*
   Sor elemz. A TREADER-tl rkl.
   Ez az elemz vonja ssze a folytat sorokat.
   Sajnos a hlye spec. miatt gy nem lehet megrni, hogy 
   folyamatosan elemezzen, mert a spec. a sorsszevonsok utn 
   az res sorokat az sszevons eredmnyeknt ltrejtt sor EL 
   teszi, gy be kell olvasni az egsz sort, hogy ezt mi is 
   megtehessk.
   gy mkdik, hogy beolvas egy teljes sort, majd megnzi hogy
   kell-e sszevonni. Ha nem, akkor abbl ad, mg el nem fogy,
   ha igen, akkor a vghez hozzolvassa a kvetkez sort, etc.
   Amikor token-t ad, akkor vagy res, vagy az olvasott sor mg be
   nem olvasott rszt trolja a sorvgjellel egytt. 
*/

#include "objgen.ch"

//*******************************************************************
#include "tbuffer.och"
#include "creader.och"
#include "token.och"

//*******************************************************************
#include "cr_lf.ch"
#include "ctoken.ch"

//*******************************************************************
#define _LPARSER_PRG_
#define _IMPLEMENT_ONEW_

#include "lparser.och"

//*******************************************************************
#define isNullChar(t)  ((t)!=nil .and.;
                        TOKEN.(t):id==TKID_CHAR .and.;
                        TOKEN.(t):str=="")

//*******************************************************************
implement readItem()
// A nullChar-okat eldobja.
local w

   while(.t.)
      if (nil==(w:=this:getParserBuffer()))
         this:readLine()
         w:=this:getParserBuffer()
      endif
      if (!isNullChar(w))
         exit
      endif
   end while
   
return w

//*******************************************************************
implement readInput()
// A #line-okat itt kell lejjebb szlltani.
// Az utnuk jv res sorokat trlni kell, a sor szm rtkt
// pedig a trlt sorok szmval megnvelni.
local t,tkId
local bos,line,iLine,i

   while(nil!=(t:=super:readInput()))
      tkId:=TOKEN.t:id
      if (tkId==TKID_BOS .and.;
          left(TOKEN.t:str,5)=="#line" .and.;
          TOKEN.t:line>1)
         // Lejjebb szllts indul
         bos:=t
         line:={}
         iLine:=TOKEN.t:line
         while(nil!=(t:=super:readInput()))
            if (TOKEN.t:id==TKID_URES)
               aadd(line,t)
            elseif (TOKEN.t:id==TKID_UJSOR)
               line:={}
               iLine++
            else
               super:unreadInput(t)
               for i:=len(line) to 1 step -1
                  super:unreadInput(line[i])
               end for
               TOKEN.bos:str:=makeHSLineStr(TOKEN.bos:file,iLine) 
               return bos
            endif
         end while
      endif
      if !(tkId==TKID_PPCOMMENT .or. tkId==TKID_CSCOMMENT)
         exit
      endif
   end while
return t

//*******************************************************************
#define ST_START                    0
// #define ST_URES                     1
#define ST_PVESSZO                  2
#define ST_PVESSZO_URES             3
#define ST_PVESSZO_UJSOR            4
#define ST_PVESSZO_UJSOR_URES       5

implement readLine()
// Amikor hvjk a parserBuffer-nek resnek kell lennie.
// Beolvas egy teljes sort, az egy soros megjegyzseket eldobja, 
// a tbb sorosakat feldolgozza, a folytat sorokat sszevonja.
// A folytat sorokat gy vonja ssze, hogy annyi j sort rak a sor
// el, amennyit sort sszevont.
// Mj.: Az reseket nem vonja ssze.
local tkId,t,i
local state, numUres,nSor:={}
               
   state:=ST_START
   this:rds()
   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      /* A PPCOMMENT-et s a CSCOMMENT-et mr a readinput-ban eldobjuk.
      if (tkId==TKID_CSCOMMENT .or. tkId==TKID_PPCOMMENT)
         // Eldobjuk.
         this:unputParserBuffer()
         this:item:=nil
      else
      */
      if (tkId==TKID_PCCOMMENT)
         // A puffer elejre annyi j sort kell beszrni, mint
         // ahny itt van.
         for i:=1 to xnumat(CHAR_LF,TOKEN.(this:item):str)
            this:ungetParserBuffer(;
               TOKEN.(this:item):copyToken(TKID_UJSOR,guessedEOL()))
         end for                 
         // Maga a megjegyzs nem kell, eldobjuk.
         this:unputParserBuffer()
         // A helyre egy 'semmi' karaktert rakunk, mert ezt pl ';' 
         // utn rtkesnek kell tekinteni.
         this:putParserBuffer(TOKEN.(this:item):copyToken(TKID_CHAR,""))
         this:unrds()
      elseif (state==ST_START)
         if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
            exit
         // elseif (tkId==TKID_URES)
         //    state:=ST_URES
         elseif (tkId==TKID_CHAR .and. TOKEN.(this:item):str==";")
            state:=ST_PVESSZO
         endif
      elseif (state==ST_PVESSZO)
         if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
            // Az j sort s a pontosvesszt el kell dobni.
            aadd(nSor,this:item)
            this:unputParserBuffer()
            this:unputParserBuffer()
            state:=ST_PVESSZO_UJSOR
         elseif (tkId==TKID_URES)
            // Ezt el kell tenni, s ha egy j sor jtt, akkor el 
            // kell dobni.
            numUres:=1
            state:=ST_PVESSZO_URES
         else
            // Pontosvessz utn valami rtkes. Vissza a startba.
            // Mj.: Ide tartozik a pontosvessz utni pontosvessz is.
            state:=ST_START
         endif
      elseif (state==ST_PVESSZO_URES)
         if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
            // Az j sort eldobjuk
            aadd(nSor,this:item)
            this:unputParserBuffer()
            // reseket eldobjuk.

            while(numUres>0)
               this:unputParserBuffer()
               numUres--
            end while

            // A pontosvesszt eldobjuk.
            this:unputParserBuffer()
            state:=ST_PVESSZO_UJSOR
            
         elseif (tkId==TKID_URES)
            // Ezt el kell tenni, s ha egy j sor jtt, akkor el 
            // kell dobni.
            numUres++
         else
            // Pontosvessz utn valami rtkes. Vissza a startba.
            // Mj.: Ide tartozik a pontosvessz utni pontosvessz is.
            state:=ST_START
         endif
      elseif (state==ST_PVESSZO_UJSOR)
         // Ez a folytat sor.
         if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
            exit
         elseif (tkId==TKID_URES)
            // Ezt egy darab space-ra kell helyettesteni.
            t:=TOKEN.(this:item):copyToken(TKID_URES,space(1))
            this:unputParserBuffer()
            this:putParserBuffer(t)
            this:item:=t
            state:=ST_PVESSZO_UJSOR_URES
         elseif (tkId==TKID_CHAR .and. TOKEN.(this:item):str==";")
            state:=ST_PVESSZO
         else
            state:=ST_START
         endif
      elseif (state==ST_PVESSZO_UJSOR_URES)
         if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
            exit
         elseif (tkId==TKID_URES)
            // Ezt el kell dobni.
            this:unputParserBuffer()
         else
            this:unrds()
            state:=ST_START
         endif   
         // if (tkId==TKID_CHAR .and. TOKEN.(this:item):str==";")
         //    state:=ST_PVESSZO
         // else
         //    state:=ST_START
         // endif
      else
         ? "LPARSER:readline(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rds()
   end while
   aeval(nSor,{|x| this:ungetParserBuffer(x)})
return nil

#ifdef OLD
   if (2<=(n:=TBUFFER.(this:parserBuffer):bItemNumber))
      utolsoUres:=;
         TKID_URES==tkId(TBUFFER.(this:parserBuffer):getBItem(n-1))
   else
      utolsoUres:=.f.
   endif

   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      if (tkId==TKID_UJSOR .or. tkId==TKID_BOS .or. tkId==TKID_EOS)
         // Itt kell elintzni a sor sszevonsokat. Sort akkor kell
         // sszevonni, ha a pufferben (az resek s az j sor kivtelvel)
         // az utols token egy ';'.
         // Ekkor a ';'-t trljk, s ha utna res jn (majd), akkor azt
         // egy ' '-re helyettestjk (elg fura specifikci, nemdebr? ;)
         // Itt kell elintzni a sor sszevonsokat.
         exit
      endif
      if (tkId==TKID_PCCOMMENT)
         // A puffer elejre annyi j sort kell beszrni, mint
         // ahny itt van.
         for i:=1 to xnumat(CHAR_LF,TOKEN.(this:item):str)
            this:ungetParserBuffer(;
               TOKEN.(this:item):copyToken(TKID_UJSOR,guessedEOL()))
         end for                 
         // Maga a megjegyzs nem kell, eldobjuk.
         this:unputParserBuffer()
         this:item:=nil
      elseif (tkId==TKID_URES .and. utolsoUres)
         // Az ez eltti is res, a kettt ssze kell vonni.
         n:=TBUFFER.(this:parserBuffer):bItemNumber
         w:=TBUFFER.(this:parserBuffer):getBItem(n-1)
         // sszevonjuk.
         t:=TOKEN.w:copyToken(TKID_URES,;
                              TOKEN.w:str+TOKEN.(this:item):str)
         this:unputParserBuffer()
         this:unputParserBuffer()
         this:putParserBuffer(t)
      endif
      if (this:item!=nil)
         utolsoUres:=tkId==TKID_URES
      endif
      this:rds()
   end while
return nil
#endif

//*******************************************************************

